package io.zipcoder;

public class StringsAndThings {

    /**
     * Given a string, count the number of words ending in 'y' or 'z' -- so the 'y' in "heavy" and the 'z' in "fez" count,
     * but not the 'y' in "yellow" (not case sensitive). We'll say that a y or z is at the end of a word if there is not an alphabetic
     * letter immediately following it. (Note: Character.isLetter(char) tests if a char is an alphabetic letter.)
     * example : countYZ("fez day"); // Should return 2
     *           countYZ("day fez"); // Should return 2
     *           countYZ("day fyyyz"); // Should return 2
     */
    public Integer countYZ(String input){
        String[] strs = input.split(" ");
        int yzCount = 0;
        for (String str : strs) {
            if (str.charAt(str.length() - 1) == 'y' || str.charAt(str.length() - 1) == 'z') {
                yzCount++;
            }
        }
        return yzCount;
    }

    /**
     * Given two strings, base and remove, return a version of the base string where all instances of the remove string have
     * been removed (not case sensitive). You may assume that the remove string is length 1 or more.
     * Remove only non-overlapping instances, so with "xxx" removing "xx" leaves "x".
     *
     * example : withoutString("Hello there", "llo") // Should return "He there"
     *           withoutString("Hello there", "e") //  Should return "Hllo thr"
     *           withoutString("Hello there", "x") // Should return "Hello there"
     */
    public String withoutString(String base, String remove){
        //String withoutString = base;
        if (base.contains(remove)) {
            for (int i = 0; i + remove.length() <= base.length(); i++) {
                String substr = base.substring(i, i + remove.length());
                if (substr.equalsIgnoreCase(remove)){
                    base = base.substring(0, i) + base.substring(i + remove.length(), base.length());
                }
            }
        }
        return base;
    }

    /**
     * Given a string, return true if the number of appearances of "is" anywhere in the string is equal
     * to the number of appearances of "not" anywhere in the string (case sensitive)
     *
     * example : equalIsNot("This is not")  // Should return false
     *           equalIsNot("This is notnot") // Should return true
     *           equalIsNot("noisxxnotyynotxisi") // Should return true
     */
    public Boolean equalIsNot(String input){
        if (countOccurrences(input, "is") == countOccurrences(input, "not")) {
            return true;
        }
        else return false;
    }

    private int countOccurrences(String input, String strToCount) {
        int count = 0;
        for (int i = 0; i + strToCount.length() <= input.length(); i++) {
            String substr = input.substring(i, i + strToCount.length());
            if (substr.equalsIgnoreCase(strToCount)){
                count++;
            }
        }
        return count;
    }


    /**
     * We'll say that a lowercase 'g' in a string is "happy" if there is another 'g' immediately to its left or right.
     * Return true if all the g's in the given string are happy.
     * example : gHappy("xxggxx") // Should return  true
     *           gHappy("xxgxx") // Should return  false
     *           gHappy("xxggyygxx") // Should return  false
     */
    public Boolean gIsHappy(String input){
        Boolean happy = true;
        for (int i = 0; i < input.length(); i++) {
            if (input.charAt(i) == 'g') {
                if ((input.charAt(i - 1) != 'g' && i == input.length() - 1) ||
                        (input.charAt(i - 1) != 'g' && input.charAt(i + 1) != 'g')) {
                    happy = false;
                    break;
                }
            }
        }
        return happy;
    }



    /**
     * We'll say that a "triple" in a string is a char appearing three times in a row.
     * Return the number of triples in the given string. The triples may overlap.
     * example :  countTriple("abcXXXabc") // Should return 1
     *            countTriple("xxxabyyyycd") // Should return 3
     *            countTriple("a") // Should return 0
     */
    public Integer countTriple(String input){
        int tripleCount = 0;
        for (int i = 0; i  + 2 < input.length(); i++) {
            if (input.charAt(i) == input.charAt(i + 1) && input.charAt(i) == input.charAt(i + 2)) {
                tripleCount++;
            }
        }
        return tripleCount;
    }
}
